<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Check array size
	PHPCUS_PARAM::CUS_ARRAY_TOO_LARGE();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, 'record_sa_schedule');
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
							'PARAM_REC_SASCHED_ID',
							'PARAM_REC_SASCHED_ACC_ACCOUNT_ID', 
							'PARAM_REC_SASCHED_REC_CLIENT_ID', 
							'PARAM_REC_SASCHED_DATE', 
							'PARAM_REC_SASCHED_STATUS'
							// , 'PARAM_REC_SASCHED_ID_FILE'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_REC_SASCHED_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_SASCHED_ID', true);
			$PARAM_REC_SASCHED_ACC_ACCOUNT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_SASCHED_ACC_ACCOUNT_ID', true);
			$PARAM_REC_SASCHED_REC_CLIENT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_SASCHED_REC_CLIENT_ID', true);
			$PARAM_REC_SASCHED_DATE = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_SASCHED_DATE', true);
			$PARAM_REC_SASCHED_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_SASCHED_STATUS', true);
			
			//$PARAM_REC_SASCHED_ID_FILE = PHPCUS_PARAM::CUS_READ_FILES('PARAM_REC_SASCHED_ID_FILE');
			$PARAM_ARRAY_COUNT = count($PARAM_REC_SASCHED_ID);
			
				
			// Validate if array has same size
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_ARRAY_SIZE_MISMATCH
			(
					[
							$PARAM_REC_SASCHED_ID,
							$PARAM_REC_SASCHED_ACC_ACCOUNT_ID, 
							$PARAM_REC_SASCHED_REC_CLIENT_ID, 
							$PARAM_REC_SASCHED_DATE, 
							$PARAM_REC_SASCHED_STATUS
							// ,$PARAM_REC_SASCHED_ID_FILE['name']
					]
			);
			
				
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$FULL_DATA_SET = [];
			$ARRAY_CTR = 0;
			
			$SAVE_MAP_ARRAY = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
				while($ARRAY_CTR < $PARAM_ARRAY_COUNT)
				{
					$SAVE_MAP_ARRAY = PHPCUS_RECORD_SA_SCHEDULE::CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					
					$SAVE_MAP_ARRAY['PARAM_REC_SASCHED_ID'] = $PARAM_REC_SASCHED_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_SASCHED_ACC_ACCOUNT_ID'] = $PARAM_REC_SASCHED_ACC_ACCOUNT_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_SASCHED_ACC_ACCOUNT_SERVER_ID'] = PHPRC_SQL_FLAGS::FLAG_BIGINT_NULL;
$SAVE_MAP_ARRAY['PARAM_REC_SASCHED_REC_CLIENT_ID'] = $PARAM_REC_SASCHED_REC_CLIENT_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_SASCHED_DATE'] = $PARAM_REC_SASCHED_DATE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_SASCHED_STATUS'] = $PARAM_REC_SASCHED_STATUS[$ARRAY_CTR];
							
					$DATA_SET = PHPCUS_RECORD_SA_SCHEDULE::CUS_SAVE_MA
					(
							$SAVE_MAP_ARRAY,
							true,
							$PDO_HANDLE
					);
			
					/*
					if
					(
						isset($PARAM_REC_SASCHED_ID_FILE['name'][$ARRAY_CTR]) && 
						empty($DATA_SET) == false && 
						isset($DATA_SET[0]['INSERTED_ID'])
					)
					{		
						$FILE_PATH = PHPRC_UPLOAD::REF_SUGGEST_PATH
						(
							PHPSET::$ROOT . '/Upload/priv/Record/sa_schedule/', 
							$DATA_SET[0]['INSERTED_ID'],
							$PARAM_REC_SASCHED_ID_FILE['name'][$ARRAY_CTR]
						);
						PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_MOVEFILE
						(
							$PARAM_REC_SASCHED_ID_FILE['tmp_name'][$ARRAY_CTR],
							$FILE_PATH,
							true
						);
					}
					*/
					
					$FULL_DATA_SET = PHPRC_PDO_MYSQL_ARRAY::REF_MERGE($FULL_DATA_SET, $DATA_SET);
					$ARRAY_CTR ++;
				}
					
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
						
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($FULL_DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>